<?php

include '../core.php';

session_start();

cabecera (1);

// El siguiente script comprueba si el identificador de la
// solicitud es valido, antes de enviar el formulario.
echo "<script language='JavaScript'>
<!--
function submit_form()
{
if (document.crt_form.crt_ID.value == '') {
alert ('Por favor introduzca un Identificador valido');
document.crt_form.crt_ID.focus();
return false;
}
document.crt_form.submit();
return true;
}
// -->
</script>

<h1>Descarga de certificados solicitados a " . $pkiris['name'] . "</h1>\n";

// Dependiendo del valor de esta variable entraremos en una 
// u otra parte del codigo
$command = $_POST["crt_command"];
$errorCode = "a0";

switch ( $command ) {
   
   // Por defecto solicitamos al usuario el identificador del 
   // certificados que quiere obtener
   default:
	   
      echo "<p>En este apartado podr&aacute; descargarse el certificado que haya solicitado previamente. Tanto sea de usuario como de servicio/servidor. No olvide que los identificadores normalmente son de la forma:</p>
      <ul>
        <li><b>Usuario:</b> nombre.apellido@organizaci&oacute;n</li>
        <li><b>Servidor:</b> FQDN.del.servidor</li>
        <li><b>Servicio:</b> servicio/FQDN.del.servidor</li>
      </ul>
      
      <div id='tbox'>
         <h3 class='head_a2b1'>Introduzca los datos</h3>
	    <div id='tbox_data_a1'>
      	    <form method='post' action='crt_get.php' name='crt_form'>
	    <div id='trow'>
	    <div id='tname'>Identificador de<br/>usuario/servidor:</div>
	       <div id='tvalue'><input type='text' name='crt_ID'  size='30' minlen='7' /></div>
	    </div>
	    <div id='trow'>
               <div id='tvalue'>
                  <input class='button' type='button' value='Continuar' onClick='submit_form()'></div>
	    </div>
      	    <input type='hidden' name='crt_command' value='crt_show'>
            </form>
         </div> <!-- tbox_data_a1 -->
      </div> <!-- tbox -->";

   break;
   
   // En esta parte se muestra informacion sobre el usuario y se le pregunta
   // que certificado quiere descargarse (en el caso de que tenga mas de uno)   
   case "crt_show":
      $crt_ID = $_POST['crt_ID'];
	     
      // Buscamos la informacion del usuario para presentar su informacion
      $filter = "(&(objectClass=pkirisEndEntity)(pkirisID=$crt_ID))";
      $errorCode = 0;
      $justthese = array("cn", "sn"); 

      $result = ldap_get_info($ldapVar['base'], $filter, $justthese); 
 
      if (!$result) {
         $errorCode = "a4b2c4d1e1";
         echo "<h2>El dentificador del usuario/servidor no pertenece a ninguna RA.</h2>";
      }
      else if ( $result['count'] <= 0 )
         $errorCode = "a4b2c4d2e1";
      else {
	
         $cn = $result[0]["cn"][0];
         $sn = $result[0]["sn"][0];
	       
         // Buscamos la informacion de los certificados que tenga 
         // el usuario en estado SIGNED
         $filter = "(&(objectClass=pkirisCertificate)(pkirisID=$crt_ID)(pkirisStatus=issued))";
         $justthese = array("pkiriscopaid", "pkiriscerttype");

         $result = ldap_get_info($ldapVar['base'], $filter, $justthese);

         if (!$result)
            $errorCode = "a4b2c4d1e1";
         else if ( $result['count'] <= 0 )
	    $errorCode = "a4b2c4d2e2";
         else {

            $crt_type = $result[0]["pkiriscerttype"][0];
	       
            // Si el usuarios tiene mas de un certificado firmado, le 
            // tenemos que dar la posibilidad de descargarse cualquiera 
            if ($result['count'] > 1) { 
               echo "<p>Actualmente dispone de varios certificados firmados. Escoja el que desee descargar.</p>";
	          
               echo "<h2>Datos sobre la solicitud del certificado (CSR)</h2>
                     <table border='0' cellpadding='0' cellspacing='0'>
                     <tr><td class='header'>Identificador</td><td class='even'>$crt_ID</td></tr>";

	       // El siguiente formulario muestra el primer certificado
	       $copaCrt1 = $result[0]["pkiriscopaid"][0];
               echo "<form method='post' action='crt_get.php' enctype='multipart/form-data'>
	       <tr><td class='header'>C&oacute;digo de solicitud</td><td class='odd'> $copaCrt1 				    
	       <input type=submit value='Mostrar'> </td></tr>
	       <input type='hidden' name='crt_command' value='crt_show2'>
               <input type='hidden' name='crt_copa' value='$copaCrt1'>
               <input type='hidden' name='crt_id' value='$crt_ID'>
               <input type='hidden' name='crt_cn' value='$cn'>
               <input type='hidden' name='crt_sn' vaue='$sn'>
               <input type='hidden' name='crt_type' value='$crt_type'>
               </form>";
		  
	       // Formulario para mostrar el segundo certificado disponible
	       $copaCrt2 = $result[1]["pkiriscopaid"][0];
	       echo "<form method='post' action='crt_get.php' enctype='multipart/form-data'>
	       <tr><td class='header'>C&oacute;digo de solicitud</td><td class='even'> $copaCrt2
	       <input type=submit value='Mostrar'> </td></tr>
	       <input type='hidden' name='crt_command' value='crt_show2'>
	       <input type='hidden' name='crt_copa' value=$copaCrt2>
	       <input type='hidden' name='crt_id' value='$crt_ID'>
	       <input type='hidden' name='crt_cn' value='$cn'>
	       <input type='hidden' name='crt_sn' vaue='$sn'>
	       <input type='hidden' name='crt_type' value='$crt_type'>
	       </form>";

		     
	       echo "<tr><td class='header'>Nombre</td><td class='odd'>" . $cn . " " . $sn ."</td></tr>";
               // Dependiendo del tipo de solicitud, mostraremos 
               // un mensaje u otro
               if ($result[0]["pkiriscerttype"][0] == "srv") 
                  echo "<tr><td class='header'>Tipo</td><td class='even'>Certificado de Servidor</td></tr></table>";
	       else 
	          echo "<tr><td class='header'>Tipo</td><td class='even'>Certificado de Usuario</td></tr></table>";
		  
	    }
	    else {
	       // Si el usuario solamente dispone de un certificado firmado, 
	       // se lo mostramos directamente	       
	       $copa = $result[0]["pkiriscopaid"][0];
	       echo "<form method='post' action='crt_get.php' enctype='multipart/form-data' name='crt_form'>
               <input type='hidden' name='crt_command' value='crt_show2'>
               <input type='hidden' name='crt_copa' value='$copa'>
               <input type='hidden' name='crt_id' value='$crt_ID'>
               <input type='hidden' name='crt_cn' value='$cn'>
               <input type='hidden' name='crt_sn' vaue='$sn'>
               <input type='hidden' name='crt_type' value='$crt_type'>
	       <body onLoad='document.crt_form.submit()'>
               </form>";
	    }	       
	 }
      }
      break;
  
  // En esta parte se muestra el contenido del certificado y se permite 
  // la descarga
  case "crt_show2":
     $crt_copa = $_POST['crt_copa'];
     $crt_ID = $_POST['crt_id'];
     $crt_cn = $_POST['crt_cn'];
     $crt_sn = $_POST['crt_sn'];
     $crt_type = $_POST['crt_type'];
 
     echo "<h2>Datos sobre la solicitud del certificado (CSR)</h2>
           <div id='tbox'>
              <h3 class='head_a2b1'>Solicitud</h3>
              <div id='tbox_data_a2'>
                <div id='trow'>
                  <div id='tname'>C&oacute;digo de Solicitud</div>
                  <div id='tvalue'>$crt_copa</div>
                </div>
                <div id='trow'>
                  <div id='tname'>Identificador</div>
                  <div id='tvalue'>$crt_ID</div>
                </div>
                <div id='trow'>
                  <div id='tname'>Nombre</div>
                  <div id='tvalue'>$crt_cn $crt_sn</div>
                </div>
                <div id='trow'>
                  <div id='tname'>Tipo de Certificado</div>";
                // Dependiendo del tipo de solicitud, mostraremos un mensaje u otro, y
                // crearemos un fichero u otro para guardar el certificado
                if ($crt_type == "srv") {
                   echo "<div id='tvalue'>Certificado de Servidor</div>\n";
                   $crtFileName = $crt_copa.".".$pkiris['certSuffix'];
                }
                else {
                   echo "<div id='tvalue'>Certificado de Usuario</div>\n";
                   $crtFileName = $crt_copa.".".$pkiris['certSuffix'];
                }
           echo "</div>
              </div>
            </div>\n";
     
     // Obtenemos el certificado del ldap	     
     $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$crt_copa)(pkirisStatus=issued))";
     $userCert = ldap_get_cert($ldapVar['base'], $filter);

     // Si ha habido algun error, mostramos mensaje y no continuamos con la descarga
     if (!$userCert) 
	$errorCode = "a4b2c4d1e2";
     else {							 

        echo "<br />
	<p> Para instalar el certificado en su navegador es necesario que utilice el mismo navegador desde el que realizó la petición del certificado. En caso contrario no podrá instalarlo</p>
        <form method='post' action='crt_get.php' enctype='multipart/form-data'>
        <input type='hidden' name='crt_copa' value='$crt_copa'>
	<input type='hidden' name='crt_type' value='$crt_type'>
	<input type='hidden' name='crtFileName' value='$crtFileName'> 
        <input type='hidden' name='crt_command' value='crt_download'>

        <h2>Datos sobre el certificado que va a descargar</h2>
	<div id='tbox'>
	  <h3 class='head_a2b1'>Certificado</h3>
	      <div id='tbox_data_a1'><pre>\n";
        
	// Verificamos si existe el fichero y si no lo creamos
        // y volcamos la info del certificado en el
	$derFile = $dirVar['crt'] . $crtFileName;
        //if (!file_exists($derFile)) {
           $der = fopen($derFile, "w");
           fputs($der, $userCert[0]);
           fclose($der);
        //}

       // Pasamos el certificado que esta en der a txt y lo 
       // tenemos en un array para manipularlo. (NO LO PASAMOS A DISCO)
       $txtCert = exec($bin['openssl'] . " x509 -text -inform DER < " .$derFile, $result);
       for($i = 1; $i < count($result); $i++)
          echo "$result[$i]\n";
      
       echo "</div>
       </div></pre>
       <input class='button' type=submit value='Instalar su certificado en el navegador'>
       </form>";
    }

    break;

      
   // En este caso se procede a la descarga del certificado 
   case "crt_download":
      $crt_copa = $_POST['crt_copa'];
      $crt_type = $_POST['crt_type'];
      $crtFileName = $_POST['crtFileName'];

      $crtFileName = $urlVar['crt'] . $crtFileName;
      echo "<iframe frameborder='0' name='cert' width='1' height='1' src='$crtFileName'></iframe><h2>Certificado descargado</h2><p>Su certificado ha sido instalado en su navegador si est&aacute; utilizando <b>el mismo navegador desde el que solicit&oacute; la petici&oacute;n de certificado.</b></p>
      <p>Por favor, compruebe en las preferencias de su navegador si el certificado se encuentra instalado en la base de datos de certificados personales</p>";
      
      $pkiLog['status'] = "download";
      $pkiLog['eee'] = $copa;
      $pkiLog['user'] = "Publico";
      $pkiLog['error'] = $errorCode;
      writeLog($pkiLog);
      
   break;

}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h2> Error en la Descarga de Certificados </h2>
         <p> No ha sido posible descargar el certificado.</p>\n";

   $pkiLog['status'] = "download";
   $pkiLog['eee'] = $copa;
   $pkiLog['user'] = "Publico";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}


pie ();

?>
